---
name: Bug Report
about: Create a bug report.
title: '[BUG] Description'
labels: 'bug'
---

### Checklist
 - [ ] Have you provided a description of the bug?
 - [ ] Have you provided your Environment information?
 - [ ] Have you provided a sample code snippet?
 - [ ] Have you provided a stack trace?
 - [ ] Have you outlined the expected behavior?

### Description
<!-- Please provide a clear and concise description of the bug. -->

### Environment Information
<!-- Please provide the version of the OS, SDK, and Environment you are experiencing the bug in. -->
 - OS Version: _(e.g. Windows 10)_
 - SDK Version: _(e.g. 1.1.0)_
 - Environment: _(e.g. Ruby 3.1.0)_

### Sample Code Snippet
<!-- Please provide a code snippet that produces or is relevant to the bug. -->
```ruby
# Sample Code Snippet
```

### Stack Trace
<!-- Please provide the stack trace that shows the bug. -->
```shell
# Stack Trace
```

### Expected Behavior
<!-- Please outline the expected behavior of the SDK. -->

### Suggested Fix
<!-- If you have a fix or a suggestion for how this bug may be resolved, describe it here. -->